﻿Type=Activity
Version=3.82
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim lstTable As List
	Dim WebView1 As WebView
	Dim edtExerciseName, edtBarWeightLb, edtBarWeightKg As EditText
	Dim btnUpdate, btnAddNew, btnDelete As Button
	Dim col, row, ID As Int
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	Activity.LoadLayout("ExercisesLayout")
	FillWebView
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub FillWebView
	Dim Query As String

	Query = "SELECT Id, Descrip as [Exercise Name], BarWeightLb as [Bar Weight Lb], BarWeightKg as [Bar Weight Kg] FROM tblExercises" 
	' the line above does the same as the line below
	' in bothe cases the WebView column names are the same as the DB column names
	' Query = "SELECT ID, FirstName, LastName, Address, City FROM " & Main.DBTableName
	WebView1.LoadHtml(DBUtils.ExecuteHtml(Main.SQL1, Query, Null, 0, True))
	lstTable = DBUtils.ExecuteMemoryTable(Main.SQL1, Query, Null, 0)
End Sub


Sub WebView1_OverrideUrl (Url As String) As Boolean
	'parse the row and column numbers from the URL
	Dim values() As String
	values = Regex.Split("[.]", Url.SubString(7))
	col = values(0)
	row = values(1)
	
	Dim val(5) As String
	val = lstTable.Get(row)
	
	ID = val(0)
	edtExerciseName.Text = val(1)
	edtBarWeightLb.Text = val(2)
	edtBarWeightKg.Text = val(3)
	
	Return True 'Don't try to navigate to this URL
End Sub

Sub btnAddNew_Click
	' adds the new record
	If RecordExists = False Then
		If ValidateFields = False Then
			Return
		End If
		Dim maps As List
		Dim mp As Map
		maps.Initialize
		mp.Initialize
		mp.Put("ID",Null)
		mp.Put( "Descrip", edtExerciseName.Text)
		mp.Put( "BarWeightLb", edtBarWeightLb.Text)
		mp.Put( "BarWeightKg", edtBarWeightKg.Text)
		maps.Add(mp)
		DBUtils.InsertMaps(Main.SQL1, "tblExercises", maps)
		FillWebView
	End If
End Sub


Sub RecordExists As Boolean
	Dim Query As String
	Dim curs As Cursor

	' checks if the record already exists
	Query = "SELECT * FROM tblExercises WHERE Descrip='" & edtExerciseName.Text & "'" 
	curs = Main.SQL1.ExecQuery(Query)
	If curs.RowCount > 0 Then
		Msgbox("This record already exists", "A T T E N T I O N")
		Return True
	Else
		Return False
	End If
End Sub

Sub btnUpdate_Click
	Dim Answ As Int
	If ValidateFields = False Then
		Return
	End If
	
	
	Answ = Msgbox2("Do you really want to update this entry ?", "ATTENTION", "Yes", "", "No", Null)

	If Answ = DialogResponse.POSITIVE Then
		Dim mp As Map
		mp.Initialize
		mp.Put("ID", ID)
		DBUtils.UpdateRecord(Main.SQL1, "tblExercises", "Descrip", edtExerciseName.Text, mp)
		DBUtils.UpdateRecord(Main.SQL1, "tblExercises", "BarWeightLb", edtBarWeightLb.Text, mp)
		DBUtils.UpdateRecord(Main.SQL1, "tblExercises", "BarWeightKg", edtBarWeightKg.Text, mp)

		FillWebView
	End If
End Sub


Sub ValidateFields As Boolean
	If edtBarWeightLb.Text = "" Then
		edtBarWeightLb.Text = "0"
	End If
	If edtBarWeightKg.Text = "" Then
		edtBarWeightKg.Text = "0"
	End If
	If edtExerciseName.Text = "" Then
		Msgbox("Please enter a Exercise Name !", "A T T E N T I O N")
		Return False
	End If
	If IsNumber(edtBarWeightLb.Text) = False Then
		Msgbox("Bar weight in LB has to be a number!", "A T T E N T I O N")
		Return False
	End If
	If IsNumber(edtBarWeightKg.Text) = False Then
		Msgbox("Bar weight in KG has to be a number !", "A T T E N T I O N")
		Return False
	End If
	If edtBarWeightKg.Text = "0" AND edtBarWeightLb.Text = "0" Then
		Msgbox("At least one bar weight has to be greater than zero !", "A T T E N T I O N")
		Return False
	End If
	Return True
End Sub


'Sub EditText1_TextChanged (Old As String, New As String)
'    If New = "" OR New = "-" OR New = "." OR New = "-." OR IsNumber(New) Then Return
'    Msgbox("error in input "&New,"Input error")
'    EditText1.Text=Old
'End Sub


Sub btnDelete_Click
	Dim Answ As Int
	
	Answ = Msgbox2("Do you really want to delete this record ?", "DELETE record", "Yes", "", "No", Null)

	If Answ = DialogResponse.POSITIVE Then
		Dim mp As Map
		Dim val(5) As String
		mp.Initialize
		mp.Put("ID", ID)
		val = lstTable.Get(row)
		mp.Put("Descrip", val(1))
		mp.Put("BarWeightLb", val(2))
		mp.Put("BarWeightKg", val(3))
		DBUtils.DeleteRecord(Main.SQL1, "tblExercises", mp)
		FillWebView
		edtExerciseName.Text = ""
		edtBarWeightLb.Text = ""
		edtBarWeightKg.Text = ""
		row = -1
		col = -1
	End If
End Sub